{===========================================================================}
{==                                                                       ==}
{==                         CHEAT VIEWER Version 3.1                      ==}
{==                  Copyright (C) 1994-96 By The GodFather               ==}
{==                                                                       ==}
{===========================================================================}

{$M, 16384,0,655350}

USES Dos,
     GUtils, GMemory, GList, GStdDlgs;

CONST
  Version    = 'Version 3.1';
  HeaderSize = 31;

{$I GCHEAT31\GC_LOGO.PAS}

TYPE
  THeader = RECORD
    Junk    : ARRAY[1..26] OF Char;
    ID      : Byte;
    NDXSize : LongInt;
  END;

  NDXRec = RECORD
    Name   : STRING[60];
    Offset : LongInt;
    Lines  : Word;
  END;

  PStr = ^TStr;
  TStr = OBJECT(TObject)
    Data: PString;
    CONSTRUCTOR Init(AData:STRING);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGame = ^TGame;
  TGame = OBJECT(TObject)
    Name      : PString;
    Offset    : LongInt;
    NumLines  : Word;
    CONSTRUCTOR Init(AName:STRING; AOffset:LongInt; ANumLines:Word);
    DESTRUCTOR Done; VIRTUAL;
  END;

  PGamesCollection = ^TGamesCollection;
  TGamesCollection = OBJECT(TSortedCollection)
    FUNCTION KeyOf(Item:Pointer): Pointer; VIRTUAL;
    FUNCTION Compare(Key1,Key2:Pointer): Integer; VIRTUAL;
  END;

  PGamesList = ^TGamesList;
  TGamesList = OBJECT(TList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
  END;

  PViewer = ^TViewer;
  TViewer = OBJECT(TBrowseList)
    FUNCTION  __GetLine(ListPos:Integer): STRING; VIRTUAL;
    PROCEDURE __HookListKeys(ListPos:Integer; VAR PressedKey:Word); VIRTUAL;
    PROCEDURE __IdleListCall(ListPos:Integer); VIRTUAL;
  END;


VAR
  Games       : PGamesCollection;
  Header      : THeader;
  GamesList   : PGamesList;
  CheatData   : PCollection;
  Viewer      : PViewer;
  HorizPos    : Byte;
  FileName    : STRING;


CONSTRUCTOR TGame.Init(AName:STRING; AOffset:LongInt; ANumLines:Word);
BEGIN
  Name     := NewStr(AName);
  Offset   := AOffset;
  NumLines := ANumLines;
END;

DESTRUCTOR TGame.Done;
BEGIN
  DisposeStr(Name);
END;




CONSTRUCTOR TStr.Init(AData:STRING);
BEGIN
  Data := NewStr(AData);
END;

DESTRUCTOR TStr.Done;
BEGIN
  DisposeStr(Data);
END;




FUNCTION TGamesCollection.KeyOf(Item:Pointer): Pointer;
BEGIN
  KeyOf := @PGame(Item)^.Name;
END;

FUNCTION TGamesCollection.Compare(Key1,Key2:Pointer): Integer;
BEGIN
  IF PString(Key1^)^ = PString(Key2^)^
    THEN Compare := 0
    ELSE IF PString(Key1^)^ < PString(Key2^)^
           THEN Compare := -1
           ELSE Compare := 1;
END;




PROCEDURE Quit;
BEGIN
  RmWin;
  SetPal(OrgPAL);
  SetBlink(True);
  Cursor(On);
  Halt;
END;

PROCEDURE LoadIndexes;
VAR DataFile:FILE; R:Word; I:Byte; NDX:NDXRec; Total,A:Word;
BEGIN
  FileName := 'GCHEAT.DAT';
  IF NOT FindFile(FileName) THEN BEGIN
                                   InfoBox('Can`t find GCHEAT.DAT',True);
                                   Quit;
                                  END;
  Assign(DataFile,FileName);
  {$I-}
    Reset(DataFile,1);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
                          InfoBox('Error opening GCHEAT.DAT',True);
                          Quit;
                        END;

  {$I-}
  BlockRead(DataFile,Header,SizeOf(Header),R);
  IF Header.ID <> $1A THEN BEGIN
                             InfoBox('Error reading GCHEAT.DAT',True);
                             Quit;
                           END;

  Total := Header.NDXSize DIV SizeOf(NDX);
  New(Games,Init(1,1));
  FOR A := 1 TO Total DO
  BEGIN
    BlockRead(DataFile,NDX,SizeOf(NDX),R);
    FOR I := Length(NDX.Name) DOWNTO 1 DO
      NDX.Name[I] := Chr($76 XOR Ord(NDX.Name[I]) XOR Ord(NDX.Name[I-1]));

    Games^.Insert(New(PGame,Init(NDX.Name,NDX.Offset,NDX.Lines)));
  END;
  Close(DataFile);
  {$I+}
END;



PROCEDURE ReadCheat(AOffset:LongInt; ANumLines:Word);
CONST LineLen = 255; BufSize = 65000;
TYPE
  PBuffer = ^TBuffer;
  TBuffer = ARRAY[1..BufSize] OF Byte;

VAR
  I: Byte;
  Index: LongInt;
  Readen: Word;
  Buffer: PBuffer;
  DataFile: FILE;
  CurrLine: STRING;
  StrLength: Byte;
  NumLines,
  CurLine : Word;

BEGIN
  Assign(DataFile,FileName);
  Reset(DataFile,1);
  Seek(Datafile,AOffset);
  NumLines := ANumLines;
  CurLine  := 0;
  New(Buffer);
  REPEAT
    BlockRead(DataFile,Buffer^,BufSize,Readen);
    Index := 0;
    REPEAT
      Move(Buffer^[Index],CurrLine,LineLen);
      CurrLine[0] := Chr(LineLen);
      StrLength   := Pos(#0#255,CurrLine)-1;
      CurrLine[0] := Chr(StrLength);
      Inc(Index,StrLength+1);
      IF CurrLine[1] = #255 THEN Delete(CurrLine,1,1);
      Inc(CurLine);
      IF CurLine = NumLines THEN Break;

      IF Length(CurrLine) <> 0 THEN
        FOR I := Length(CurrLine) DOWNTO 1 DO
          CurrLine[I] := Chr(Ord(CurrLine[I]) XOR Ord(CurrLine[I-1]));

      CheatData^.Insert(New(PStr, Init(CurrLine)));
    UNTIL Index >= Readen;
  UNTIL (CurLine = NumLines) OR (Readen <> SizeOf(Buffer^));
  Close(DataFile);
  Dispose(Buffer);
END;



PROCEDURE Print;
CONST PrnMassages : ARRAY[0..4] OF STRING[15] = ('','is out of paper','is off line','is busy','error');
VAR P:PStr; I,R:Word; OK:Boolean; Regs:Registers; S:STRING;
BEGIN
  I  := 0;
  OK := False;
  IF PrinterReady
    THEN BEGIN
           FOR I := 1 TO CheatData^.Count DO
           BEGIN
             P := CheatData^.At(I-1);
             S := GetStr(P^.Data)+#13#10;
             FOR R := 1 TO Length(S) DO
             BEGIN
               Regs.AH := $00;
               Regs.DX := $00;
               Regs.AL := Ord(S[R]);
               Intr($17,Regs);
             END;
           END;
         END
    ELSE InfoBox('Printer '+prnMassages[Ord(PrinterStatus)],True);
END;



FUNCTION TViewer.__GetLine(ListPos:Integer): STRING;
VAR S:PStr; St:STRING;
BEGIN
  S := CheatData^.At(ListPos-1{+2});
  St := ' '+GetStr(S^.Data);
  __GetLine := Copy(St,HorizPos,77);
END;

PROCEDURE TViewer.__IdleListCall(ListPos:Integer);
BEGIN
  WriteHScrollBar(27,78,MaxY,$2A,HorizPos,81);
END;

PROCEDURE TViewer.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
VAR OldHorizPos: Byte;
BEGIN
  OldHorizPos := HorizPos;
  CASE PressedKey OF
    80,80+32: Print;
     kbEnter: PressedKey := kbEsc;
      kbLeft: IF HorizPos <> 1  THEN Dec(HorizPos,5);
     kbRight: IF HorizPos <> 81 THEN Inc(HorizPos,5);
  kbCtrlPgUp: HorizPos := 1;
  kbCtrlPgDn: HorizPos := 1;
  kbCtrlLeft: HorizPos := 1;
 kbCtrlRight: HorizPos := 81;
  END;
  IF OldHorizPos <> HorizPos THEN ReDraw;
END;


PROCEDURE ViewCheat(Which:Integer);
VAR Game:PGame;
BEGIN
  Game := Games^.At(Which-1);
  New(CheatData, Init(1,15));
  ReadCheat(HeaderSize+Header.NDXSize+Game^.Offset, Game^.NumLines);
  OpenWin(1,6,79,MaxY-5,$2A,$2F,Single1,Game^.Name^);
  WriteHi(3,MaxY,$28,$2E,' Press ~P~ to print text ');
  HorizPos := 1;
  Viewer := New(PViewer,
                    Init(2,7,
                         77,MaxY-7,
                         CheatData^.Count{-2},
                         True,80,7,MaxY-1));
  Viewer^.Process;
  RmWin;
  Dispose(Viewer, Done);
  Dispose(CheatData, Done);
END;


FUNCTION TGamesList.__GetLine(ListPos:Integer): STRING;
VAR Game:PGame; S,S2:STRING[65]; A:Byte;
BEGIN
  Game := Games^.At(ListPos-1);
  S    := GetStr(Game^.Name);
  S2   := Copy(S, LastPos(' ',S), 255);
  Delete(S,LastPos(' ',S), 255);
  __GetLine := ' '+PadLeft(S,45,' ')+PadRight(S2,15,' ');
END;

PROCEDURE TGamesList.__HookListKeys(ListPos:Integer; VAR PressedKey:Word);
BEGIN
  IF PressedKey = kbEnter THEN ViewCheat(ListPos);
END;



BEGIN
  SetPal(AltPAL);
  Cursor(Off);
  SetBlink(False);
  LoadIndexes;
  MkWin(11,1,59,3,$19,Single1,'');
  WriteBetween(11,69,2,$1E,'CHEAT VIEWER '+Version);
  WriteBetween(11,69,3,$1E,'Copyright (C) 1996 by The GodFather');
  OpenWin(9,6,63,MaxY-7,$5D,$5B,Special2,'Games list');
  WriteHi(50,MaxY-1,$57,$5A,' Total cheats: ~'+IntToStr(Games^.Count)+'~ ');
  New(GamesList);
  WITH GamesList^ DO
  BEGIN
    Init(10,7,62,MaxY-8,Games^.Count,False,True,11,MaxY-1,'',True,72,7,MaxY-2,lPurplePal);
    Pallette[lBar] := $30;
    Process;
  END;
  Dispose(Games, Done); RmWin;
  RmWin;
  SetPal(OrgPAL);
  SetBlink(True);
  ClrScr(7);
  PartRestore(1,(MaxY DIV 2) - 11,80,((MaxY DIV 2) - 11)+24,_GCheat_LOGO);
  PosCursor(1,MaxY-1);
  Cursor(On);
END.